<?php

namespace Drupal\partial\TwigExtension;

use Twig\Extension\AbstractExtension;
use Twig\TwigFilter;
use Twig\TwigFunction;

/**
 * PartialTwigExtension class.
 */
class PartialTwigExtension extends AbstractExtension {

  /**
   * {@inheritdoc}
   */
  public function getName() {
    return 'partial';
  }

  /**
   * {@inheritdoc}
   */
  public function getFunctions() {
    return array(
      new TwigFunction('partial', array($this, 'partialFunction'), array(
        'name' => NULL,
        'context' => [],
      )),
    );
  }

  /**
   * {@inheritdoc}
   */
  public function getFilters() {
    return array(
      new TwigFilter('partial', array($this, 'partialfilter'), array(
        'name' => NULL,
      )),
    );
  }

  /**
   * Render partial.
   */
  public function partialFunction($name, $context = array()) {
    $build['partial'] = [
      '#theme' => 'partial',
      '#name' => $name,
      '#context' => $context,
    ];
    return $build;
  }

  /**
   * Render partial as a Twig Filter.
   */
  public function partialFilter($context = array(), $name = NULL) {
    $build['partial'] = [
      '#theme' => 'partial',
      '#name' => $name,
      '#context' => $context,
    ];
    return $build;
  }

}